﻿namespace UltraGridSyncScrolling
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.uiElementViewerDialog1.Show();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var data = this.GetData();
            this.ultraGrid1.SetDataBinding(data, data.Tables[0].TableName);
            this.ultraGrid1.Rows.ExpandAll(true);

            this.ultraGrid2.SetDataBinding(data, data.Tables[0].TableName);
            this.ultraGrid2.Rows.ExpandAll(true);
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            DataTable t2 = ds.Tables.Add("table2");
            t2.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t2.Columns.Add("pid", typeof(int));
            t2.Columns.Add("Name", typeof(string));
            t2.Columns.Add("Address", typeof(string));
            t2.Columns.Add("Number", typeof(int));

            DataTable t3 = ds.Tables.Add("table3");
            t3.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t3.Columns.Add("pid", typeof(int));
            t3.Columns.Add("Name", typeof(string));
            t3.Columns.Add("Age", typeof(int));
            t3.Columns.Add("Height", typeof(double));


            DataTable t4 = ds.Tables.Add("table4");
            t4.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t4.Columns.Add("pid", typeof(int));
            t4.Columns.Add("Name", typeof(string));
            t4.Columns.Add("Expired", typeof(bool));

            ds.Relations.Add(t1.Columns["id"], t2.Columns["pid"]);
            ds.Relations.Add(t1.Columns["id"], t3.Columns["pid"]);
            ds.Relations.Add(t2.Columns["id"], t4.Columns["pid"]);

            ds = this.AddData(ds);

            return ds;
        }

        private DataSet AddData(DataSet ds)
        {
            ds.Tables["table1"].Rows.Add(new object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Motorcycles", 10, 320, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Clothes", 40, 69, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Shoes", 24, 40.6, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Games", 53, 50, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Books", 42, 22, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Movies", 38, 19, new DateTime(2009, 02, 28) });

            ds.Tables["table2"].Rows.Add(new object[] { null, 0, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 1, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 2, "Coca - Cola", " Somewhere", 2 });
            ds.Tables["table2"].Rows.Add(new object[] { null, 3, "Coca - Cola", " Somewhere", 2 });

            ds.Tables["table3"].Rows.Add(new object[] { null, 1, "George", 43, 32.5 });
            ds.Tables["table3"].Rows.Add(new object[] { null, 2, "George", 43, 32.5 });
            ds.Tables["table3"].Rows.Add(new object[] { null, 3, "George", 43, 32.5 });
            ds.Tables["table3"].Rows.Add(new object[] { null, 0, "George", 43, 32.5 });

            ds.Tables["table4"].Rows.Add(new object[] { null, 0, "Coffee Shop ", true });
            ds.Tables["table4"].Rows.Add(new object[] { null, 1, "Coffee Shop ", true });
            ds.Tables["table4"].Rows.Add(new object[] { null, 2, "Coffee Shop ", true });
            ds.Tables["table4"].Rows.Add(new object[] { null, 3, "Coffee Shop ", true });

            return ds;
        }

        private void UltraGrid_AfterRowRegionScroll(object sender, RowScrollRegionEventArgs e)
        {
            if (sender.Equals(this.ultraGrid2))
            {
                ultraGrid1.ActiveRowScrollRegion.ScrollPosition = e.RowScrollRegion.ScrollPosition;
            }
            if (sender.Equals(ultraGrid1))
            {
                ultraGrid2.ActiveRowScrollRegion.ScrollPosition = e.RowScrollRegion.ScrollPosition;
            }
        }
    }
}
